'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'   Magicard Printer Removal Script v2.10                                                '
'   2.0:                                                                                '
'       -Printer models updated to reflect printer models in driver 2.0.28.0            '
'           Names taken from 2.0.28.0 inf file.                                         '
'       -Renamed Ultra to Magicard.                                                     '
'                                                                                       '
'   2.1:                                                                                '
'       -New Models from 2.0.30 inf file                                                '
'               -Pro2Mon.dll                                                            '
'                                                                                       '
'   2.3:    03/07/2018                                                                  '
'       -Removal of files in PPC folder added                                           '
'       -Removal of status.exe added                                                    '
'       -Detection of 'magicard' in inf files added for PNP/INF file removal            '
'       -GetWinVersion fixed                                                            '
'                                                                                       '
'   2.4:    24/10/2018                                                                  '
'       -Additional whitelabel models added                                             '
'       -Removal of files in PPC folder modified                                        '
'                                                                                       '
'   2.5:    20/03/2019                                                                  '
'       -Additional whitelabel models added                                             '
'                                                                                       '
'   2.6:    01/07/2019                                                                  '
'       -Additional whitelabel models added                                             '
'                                                                                       '
'   2.7:    23/10/2019                                                                  '
'       -Additional whitelabel models added                                             '
'       -Printer model array modified to prevent over run                               '
'                                                                                       '
'   2.8:    06/12/2019                                                                  '
'       -Additional whitelabel models added                                             '
'                                                                                       '
'   2.9:    19/10/2021                                                                  '
'       -Additional whitelabel models added                                             '
'                                                                                       '
'   2.10:    20/10/2021                                                                 '
'       -PNP Removal Bug fixed (Repetitive call)                                        '
'       -Removal of Apps & Features entries for installer updated                       '
'                                                                                       '
'   2.11:    14/11/2022                                                                 '
'       -Additional whitelabel models added                                             '
'                                                                                       '
'   Gavin Relph                             Magicard Ltd                                '
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'list of printer models to remove
Dim aModelMask
aModelMask = Array("Magicard Enduro",_
                   "Magicard MC200",_
                   "Magicard Pronto",_
                   "Magicard Rio Pro",_
                   "IDville ID Maker",_
                   "Intersider Authentys",_
                   "Polaroid P4500S",_
                   "Polaroid P2500S",_
                   "PPC ID 2000",_
                   "PPC ID 2100",_
                   "PPC ID 3100" ,_
                   "ID Maker Value",_
                   "ID Maker Advantage",_
                   "ID Maker Secure",_
                   "XR160",_
                   "Fagoo P310e",_
                   "PPC ID 2300",_
                   "PPC ID 3300",_
                   "XR260",_
                   "Magicard Rio/Tango 2e",_
                   "Magicard X-Series",_
                   "Magicard Alto",_
                   "Magicard Opera",_
                   "Magicard Tempo",_
                   "Magicard Avalon",_
                   "EDIsecure DCP100",_
                   "Card Rewrite Printer A",_
                   "Card Rewrite Printer B",_
                   "Secuprinter 200",_
                   "Pridento+",_
                   "Pridento",_
                   "ING171",_
                   "Identity Pro",_
                   "DoH",_
                   "Pridento Pro",_
                   "Pridento Pro Xtended",_
                   "Magicard Enduro+",_
                   "Magicard Rio Pro Xtended",_
                   "Magicard Optima",_
                   "Magicard Helix",_
                   "PPC ID 2350e",_
                   "ilinkcard iT-2600",_
                   "IDentilam DOPPIE 100",_
                   "IDentilam DOPPIE 200",_
                   "IDentilam DOPPIE 300",_
                   "PPC RTP 7500w",_
                   "PT Smart P-Card",_
                   "Orphicard Duplet",_
                   "Authentys RetraX",_
                   "ScreenCheck SC2500",_
                   "ScreenCheck SC4500",_
                   "ScreenCheck SC6500",_
                   "XR160",_
                   "XR260",_
                   "Matica M300",_
                   "Matica M500",_
                   "Authentys",_
                   "Magicard Rio Pro LE",_
                   "Magicard Enduro3E LE",_
                   "Aisino JKE700",_
                   "Aisino JKE160C",_
                   "Aisino JKE701C",_
                   "Pridento Open Data",_
                   "Pridento+ Open Data",_
                   "AlphaCard PILOT",_
                   "AlphaCard COMPASS",_
                   "AlphaCard PRO 100",_
                   "AlphaCard PRO 500",_
                   "AlphaCard PRO 700",_
                   "Magicard Rio Pro 360",_
                   "PriceCardPro LITE",_
                   "PriceCardPro DUO",_
                   "PriceCardPro FLEX",_
                   "Magicard Rio Pro 360 Xtd",_
                   "Magicard Helix RT",_
                   "DTP MK I",_
                   "DTP MK II",_
                   "DTP MK III",_
                   "Titan T3",_
                   "Titan T5",_
                   "Elliaden Caroline",_
                   "ID Maker Secure 360",_
                   "Authentys Pro 360",_
                   "AlphaCard PRO 700",_
                   "DTP MK III",_
                   "Rio Pro 360 LE",_
                   "ScreenCheck SC6500",_
                   "Titan T5",_
                   "PPC ID 3350e",_
                   "Pridento Pro 360",_
                   "Magicard Rio Pro Select",_
                   "Pridento Pro 360 Xtended",_
                   "PriceCardPro FLEX",_
                   "Magicard Ultima",_
                   "Magicard 600",_
                   "Magicard 600 Xtd",_
                   "Cardmaker CM260",_
                   "Cardmaker CM360",_
                   "AlphaCard PRO 750",_
                   "Magicard Pronto NEO",_
                   "Magicard Enduro NEO",_
                   "Magicard Nova",_
                   "Magicard 360 NEO",_
                   "Magicard 300",_
                   "Authentys 300",_
                   "Pridento 300",_
                   "Elliaden Caroline 300",_
                   "AlphaCard PRO 550",_
                   "ID Maker EDGE",_
                   "ID Maker APEX",_
                   "PPC ID 3000",_
                   "PPC ID 4000",_
                   "Magicard 500",_
                   "Magicard D",_
                   "Magicard K",_
                   "BOOD 680",_
                   "Fagoo P360E",_
                   "Goodcard XR260D",_
                   "Ying ING550",_
                   "Goodcard XR360K",_
                   "PfS2-360",_
                   "DoH 300",_
                   "Magicard Pronto 100",_
                   "ID Maker Value.",_
                   "Magicard Pronto.",_
                   "ID Maker ARC",_
                   "Magicard 100 NEO",_
                   "ID Maker Value.",_
                   "Magicard Pronto.",_
                   "ID Maker ARC",_
                   "Cardmaker CMK",_
                   "AlphaCard PRO 150",_
                   "PriceCardPro 100",_
                   "PriceCardPro FLEX+",_
                   "EasyBadge 3.0",_
                   "Magicard Pronto NEO.",_
                   "AlphaCard PRO 100.",_
                   "XR160.",_
                   "AlphaCard PILOT.",_
                   "Centena Edge",_
                   "Magicard 300NEO",_
				   "Magicard 600NEO")

'list of product GUID's that are/have been used for Magicard V2 MSI's these need to be updated with each new release
Dim aProductcode(55)
aProductcode(1)="F9AF1A32-6C16-40C3-8B50-875AEF66D620"	'2.0.0.0 w32x86
aProductcode(2)="2EFCA3F2-1FE7-457C-9979-28387779C09A"	'2.0.0.0 x64
aProductcode(3)="1962B762-CB64-4D6F-BE95-EF0192711111"	'2.0.1.0 w32x86
aProductcode(4)="C14359D4-9067-48C5-AC30-6C783F36A78D"	'2.0.1.0 x64
aProductcode(5)="1962B762-CB64-4D6F-BE95-EF0192711111"	'2.0.2.0 w32x86
aProductcode(6)="318D8594-613C-4B87-897C-611B4D9658DB"	'2.0.2.0 x64
aProductcode(7)="91D73EC9-FF06-4C5B-9960-1EE8309ED826"	'2.0.3.0 w32x86
aProductcode(8)="D2E82ADA-9248-44FD-ACAB-2532D3704DBB"	'2.0.3.0 x64
aProductcode(9)="AF53C8B6-2FAE-4C2B-91E4-3001A0E1CA4E"	'2.0.4.0 w32x86
aProductcode(10)="E0F8F025-2C1E-4B54-A334-AE1902D830B2"	'2.0.4.0 x64
aProductcode(11)="7C43942B-ADEA-4CDB-A2A6-A763FB8C14AF"	'2.0.5.0 w32x86
aProductcode(12)="11ACDB30-FBF3-41DE-8DF6-DDABCCEB141D"	'2.0.5.0 x64
aProductcode(13)="AEF47B75-EAB0-4B19-AE0E-385AF819575E"	'2.0.5.0 w32x86 PNP only
aProductcode(14)="E5669376-0D56-4299-991B-82FFE7302CB0"	'2.0.5.0 x64 PNP only
aProductcode(15)="6A327BC2-9A75-49A3-AE04-8A3066044236"	'2.0.5.0 w32x86 PNP only Pebble edition
aProductcode(16)="598F65A0-1006-48CB-A0AC-D755614888F8"	'2.0.5.0 x64 PNP only Pebble edition
aProductcode(17)="CB840C00-54AC-493B-9FB7-77F2A4A7B6B4"	'2.0.6.0 w32x86 OEM
aProductcode(18)="D6B2DF1C-4398-4404-84BE-4E3A8BC21A4C"	'2.0.6.0 x64 OEM
aProductcode(19)="F9BE4CB0-D985-4068-BBFD-42D8ED69C6A3"	'2.0.6.0 w32x86 PNP Only
aProductcode(20)="199CA3C1-FCD6-4988-B5DA-F6ECCE784B5D"	'2.0.6.0 x64 PNP Only
aProductcode(21)="330AF81F-C7AE-478D-B7ED-0CA947033719"	'2.0.7.0 w32x86 OEM
aProductcode(22)="00657BE2-4051-4E4E-9F26-CFACE6A44C8C"	'2.0.7.0 x64 OEM
aProductcode(23)="686237CF-52F0-4474-BF88-1413D6DDD237"	'2.0.7.0 w32x86 OEM BETA 2.1
aProductcode(24)="790033C2-8284-4206-BB98-919FEB52B3C9"	'2.0.7.0 x64 OEM BETA 2.1
aProductcode(25)="400EE9A7-A5CF-43F2-B4FF-CB5B797E38FC"	'2.0.7.0 w32x86 OEM BETA 2.2
aProductcode(26)="DDF37E4E-2BFB-4140-A2DA-6BD62FF435A1"	'2.0.7.0 x64 OEM BETA 2.2
aProductcode(27)="0473539A-D2EC-4AC4-A14C-10DB0B986763"	'2.0.7.0 w32x86 PNP Only
aProductcode(28)="B7B28077-430B-4EF2-8388-C5BAC239EF09"	'2.0.7.0 x64 PNP Only
aProductcode(29)="850C9271-7F81-4F31-B344-545D7CE7D219" '2.0.8.0 w32x86 OEM
aProductcode(30)="9EB40AD4-932F-4562-AAB7-5B04F4D1B304" '2.0.8.0 x64 OEM
aProductcode(31)="7EE3A5DF-B7C9-478D-A510-0C431BCA9DB1" '2.0.8.0 w32x86 PNP Only
aProductcode(32)="DED6A8C7-7C8E-423C-AEF5-D117623B9155" '2.0.8.0 x64 PNP Only
aProductcode(33)="C5FDC398-34E1-4625-AE13-AE78713BF1AF"	'2.8.1.0 w32x86 OEM
aProductcode(34)="625DEA9F-BC14-4803-B3C1-255DDAAFC78A"	'2.8.1.0 x64 OEM
aProductcode(35)="15E82004-1BDD-4C99-ADC6-4447D304BE38"	'2.8.1.0 w32x86 PNP Only
aProductcode(36)="3D7CCF28-B83B-423C-80CE-853366284714"	'2.8.1.0 x64 PNP Only
aProductcode(37)="CE911850-C1C2-4E0D-9BF6-D06AB03B543B" '2.9.0.0 w32x86 OEM
aProductcode(38)="4D034ACD-1933-467D-A8D9-5E3697B2041E"	'2.9.0.0 x64 OEM
aProductcode(39)="0F0E315B-CFBE-4542-8226-2949E6CC6EBE" '2.10.0.0 w32x86 OEM
aProductcode(40)="A9C5DDD4-43D8-4C06-BE8D-92313FBF5CEC"	'2.10.0.0 x64 OEM
aProductcode(41)="ADA0EBF5-D753-4C63-96F8-D2607D87BAF2" '2.10.0.0 w32x86 PNP Only
aProductcode(42)="082652C5-C680-4A74-8FA0-6EAD9C169B28"	'2.10.0.0 x64 PNP Only
aProductcode(43)="5B0571AF-A68C-44B7-B7F3-74FE9F4DD5BF" '2.11.0.0 w32x86 OEM
aProductcode(44)="B27F2D73-9A83-45A3-98CC-926D595C70D8"	'2.11.0.0 x64 OEM
aProductcode(45)="77C140C2-D325-433F-9979-F0819AF8D93B" '2.11.0.0 w32x86 PNP Only
aProductcode(46)="B2DF96B9-5B91-4025-819F-A442A639D690"	'2.11.0.0 x64 PNP Only
aProductcode(47)="060C32B8-0E20-4775-AE63-3AA8DD27E385" '2.12.0.0 w32x86 OEM
aProductcode(48)="8B96F69E-1956-4A81-BE27-B0088361B325"	'2.12.0.0 x64 OEM
aProductcode(49)="57785D4F-43B5-4C47-B2F1-403C6FEFAF6D" '2.12.0.0 w32x86 PNP Only
aProductcode(50)="781E0D5F-EA22-4FBD-B18C-E0431CF31664"	'2.12.0.0 x64 PNP Only
aProductcode(51)="060C32B8-0E20-4775-AE63-3AA8DD27E385" '2.12.0.0 w32x86 OEM - Optima
aProductcode(52)="8B96F69E-1956-4A81-BE27-B0088361B325"	'2.12.0.0 x64 OEM - Optima
aProductcode(53)="85597B9A-EFDC-4423-9EE1-D184C9EBC7BF" '2.13.0.0 w32x86 OEM
aProductcode(54)="1FF11E8B-D65B-4FA0-B2A9-E68B91236A37"	'2.13.0.0 x64 OEM
aProductcode(55)="0F1729DA-0C3D-4AFE-B7F8-D86DB951A445"	'2.13.0.0 > GUID for new installer

'Registry key Root key constants
	Const HKEY_CLASSES_ROOT		= &H80000000
	Const HKEY_CURRENT_USER		= &H80000001
	Const HKEY_LOCAL_MACHINE	= &H80000002
	Const HKEY_USERS			= &H80000003
	Const HKEY_CURRENT_CONFIG	= &H80000005

'App Name for use within the script
sAppName="Magicard Driver Removal"

dim brestart
brestart=false

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''	start of fuction calls '''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'force to run vbscript as cscript (in console)
    Dim Arg, Str
    If Not LCase( Right( WScript.FullName, 12 ) ) = "\cscript.exe" Then
	CreateObject( "WScript.Shell" ).Run "cscript //nologo """ &  WScript.ScriptFullName
        WScript.Quit
    End If

'run sub routines and functions
 on error resume next
 	wscript.echo "-----------------------------------------------"
	wscript.echo "| Magicard Printer Driver Removal Version 2.10|"
	wscript.echo "-----------------------------------------------"
	wscript.echo ""
	wscript.echo sAppName & " is starting"
	WriteToFile("++++++++++Magicard Electronics Card Printer Removal Tool++++++++++")
	WriteToFile("Removal Started")
	sArchitecture=funcArchitecture
	wscript.echo sAppName & ": Clearing print jobs"
	WriteToFile(sAppName & ": Clearing print jobs")
	for each sModelMask in aModelMask
		DeletePrintJobs sModelMask
	Next
	wscript.echo sAppName & ": Finished clearing print jobs"
	WriteToFile(sAppName & ": Finished clearing print jobs")
	wscript.echo sAppName & ": Removing printers"
	WriteToFile(sAppName & ": Removing printers")
	for each sModelMask in aModelMask
		RemovePrinterAndPort sModelMask
	Next
	wscript.echo sAppName & ": Finished removing printers"
	WriteToFile(sAppName & ": Finished removing printers")
	wscript.echo sAppName & ": Removing drivers"
	WriteToFile(sAppName & ": Removing drivers")
	for each sModelMask in aModelMask
		RemoveDriver sModelMask
	Next

	if GetWinVersion >= 6 then
		wscript.echo sAppName & ": Removing PNP drivers"
		WriteToFile(sAppName & ": Removing PNP drivers")
		RemovePNPDrivers
	elseif GetWinVersion < 6 then
		wscript.echo sAppName & ": Removing INF files"
		WriteToFile(sAppName & ": Removing INF files")
		RemoveINFfiles
	end if
	wscript.echo sAppName & ": Finished removing drivers"
	WriteToFile(sAppName & ": Finished removing drivers")
	wscript.echo sAppName & ": Stopping Print Spooler"
	if stopspooler then
		WriteToFile(sAppName & ": Print spooler stopped")
	else
		WriteToFile(sAppName & ": ************* Failed to stop print spooler *************")
	end if
	wscript.echo sAppName & ": Removing redundant registry keys"
	WriteToFile(sAppName & ": Removing redundant registry keys")
	RemoveRegKeys aModelMask
	wscript.echo sAppName & ": Redundant registry keys removed"
	wscript.echo sAppName & ": Removing redundant files"
	WriteToFile(sAppName & ": Removing redundant files")
	RemoveFiles sArchitecture
	wscript.echo sAppName & ": Finished removing redundant files"
	WriteToFile(sAppName & ": Finished removing redundant files")
	wscript.echo sAppName & ": Removing redundant Folders"
	WriteToFile(sAppName & ": Removing redundant Folders")
	RemoveFolders aModelMask, sArchitecture
	wscript.echo sAppName & ": Redundant Folders Removed"
	WriteToFile(sAppName & ": Redundant Folders Removed")
	wscript.echo sAppName & ": Starting Print Spooler"
	WriteToFile(sAppName & ": Starting Print Spooler")
	if startspooler then
		WriteToFile(sAppName & ": Print spooler started")
	else
		WriteToFile(sAppName & ": ************* Failed to start print spooler *************")
	end if
	Wscript.echo sAppName & ": " & "Removal complete please check log for details"
	WriteToFile("Removal Complete")
	'restart is emp files are present
	if brestart=true then
		Wscript.echo sAppName & ": " & "Restart required"
		WriteToFile("------------- Restart required! -------------")

		result=msgbox("Your system requires a restart to complete the removal" & vbCrlf &_
					"do you wish to restart now?",vbCritical+vbYesNo,"System Restart")
		select case result
			case vbYes
				WriteToFile("------------- Removal Complete Restart Selected! -------------")
				restart
				msgbox("Now restarting")
			case vbNo
				writeToFile("------------- Removal Complete Restart required manually! -------------")
				msgbox("not restarting")
		end select
	else
		writeToFile("------------- Removal Complete Restart Not required -------------")
	end if
	If Err.Number <> 0 Then
		WriteToFile("************* Error With Removal Tool: " & Err.Description & " on line " & Err.Line & " *************")
		Err.Clear
	end if
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''' end of function calls ''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''' Start of Functions and Sub routines '''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Function GetWinVersion()
'get windows version returns windows version
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	Set oss = objWMIService.ExecQuery ("Select * from Win32_OperatingSystem")
	For Each os in oss
		GetWinVersion=left(os.Version,instr(1,os.Version,".",0)-1)
		'GetWinVersion=os.Version
	Next
	Set objWMIService = nothing
	Set oss =nothing
end function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function funcArchitecture()
'get windows architecture returns whether 32 or 64 bit OS
	set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	Set WshShell =  CreateObject("WScript.Shell")
	Set WshProcEnv = WshShell.Environment("Process")
	system_architecture= WshProcEnv("PROCESSOR_ARCHITECTURE")
	select case system_architecture
	case "x86"
		funcArchitecture= "w32x86"
	case "AMD64"
		funcArchitecture="x64"
	case else
		wscript.echo " OS not supported"
		wscript.quit
	end select
	Set objWMIService = Nothing
	Set WshShell = nothing
	Set WshProcEnv = nothing
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
function stopspooler()
'stop spooler returns a boolean to indicate success
	stopspooler=false
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	objWMIService.Security_.Privileges.AddAsString "SeLoadDriverPrivilege", True
	set objSpooler = objWMIService.Get("Win32_Service.Name='Spooler'")
	objSpooler.StopService()
	WScript.Sleep 2000
	set objSpooler = objWMIService.Get("Win32_Service.Name='Spooler'")
	if objSpooler.started=false then
		stopspooler=true
	end if
	set objWMIService = nothing
	set objSpooler = nothing
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function startspooler()
'start spooler returns a boolean to indicate success
	startspooler=false
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	objWMIService.Security_.Privileges.AddAsString "SeLoadDriverPrivilege", True
	set objSpooler = objWMIService.Get("Win32_Service.Name='Spooler'")
	objSpooler.StartService()
	WScript.Sleep 10000
	set objSpooler = objWMIService.Get("Win32_Service.Name='Spooler'")
	if objSpooler.started=true then
		startspooler=true
	end if
	set objWMIService = nothing
	set objSpooler = nothing
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub DeletePrintJobs(sModelMask)
'deletes all print jobs in spooler for relevant printer and writes to log file jobs removed
'using the WriteToFile sub routine
	on error resume next
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	Set colPrintQueue =  objWMIService.ExecQuery("Select * from Win32_Printjob where DriverName like '%" & sModelMask & "%'")
	if colPrintQueue.count<>0 then
		For each objPrintJob in colPrintQueue
				WriteToFile("Removing Print job in spooler for: " & objPrintJob.DriverName)
				sJob=objPrintJob.document
				objPrintJob.Delete_

'				set deljob = objWMIService.ExecQuery("Select * from Win32_Printjob where Name like '%" & 'sJob & "%'")
'				if isnull(deljob) = "" then
'					WriteToFile(sJob & " Deleted successfully")
'				else
'					WriteToFile("Failed to Delete Print Job " & sJob)
'				end if
		Next
	end if
	Set colPrintQueue =Nothing
	Set objWMIService = Nothing
	If Err.Number <> 0 Then
		WriteToFile("************* Error deleting print jobs: " & Err.Description & " on line " & Err.Line & " *************")
		Err.Clear
	end if
end sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub RemovePrinterAndPort(sModelMask)
'deletes all printers and ports for relevant printer and writes to log file printers and ports removed
'using the WriteToFile sub routine
	On Error Resume Next
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	Set colInstalledPrinters =  objWMIService.ExecQuery("Select * from Win32_Printer where name like'" & sModelMask & "%'")
	if colInstalledPrinters.count<>0 then
'		if colInstalledPrinters.name
			For each objPrinter in colInstalledPrinters
				if objPrinter = sModelMask then
					Set colInstalledPorts =  objWMIService.ExecQuery("Select * from Win32_TCPIPPrinterPort where name like '" & objPrinter.PortName & "'")
					WriteToFile("About to remove Printer: " & sModelMask)
					objPrinter.Delete_
'					if objPrinter.name="" then
'						WriteToFile("Failed to remove Printer " & sModelMask )
'					else
						WriteToFile("Printer " & sModelMask & " removed successfully")
'					end if
					WScript.Sleep 100
					For Each objPort in colInstalledPorts
						WriteToFile("About to remove port: " & objPrinter.PortName)
						sPort=objPort.Name
						objPort.Delete_
'						if objPort.name="" then
							WriteToFile("Port " & sPort & " removed successfully")
'						else
'							WriteToFile("************* Failed to remove Port " & sPort & " *************" )
'						end if
					Next
				end if
			Next
	end if
	Set colInstalledPrinters = Nothing
	Set colInstalledPorts = nothing
	Set objWMIService = Nothing
	If Err.Number <> 0 Then
		WriteToFile("************* Error removing printer: " & Err.Description & " on line " & Err.Line & " *************")
		Err.Clear
	end if
End sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub MsiUninstall(aKey)
'uses the msiexec.exe to remove the driver using the GUID. writes details to the log file
'using the WriteToFile sub routine
	'uninstall the driver using the MSI and the GUID
	set wshshell = CreateObject("Wscript.Shell")
	Const HKEY_LOCAL_MACHINE = &H80000002
	Set objReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")
	objReg.Security_.Privileges.AddAsString "SeLoadDriverPrivilege", True

	for each sProductCode in aKey
		Dim oReg: Set oReg = GetObject("winmgmts:!root/default:StdRegProv")
		KeyPath="SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{" & sProductCode & "}"
		If oReg.EnumKey(HKEY_LOCAL_MACHINE, KeyPath, arrSubKeys) = 0 Then
			WshShell.Run "msiexec /x {" & sProductCode & "} /q",1,true
			If oReg.EnumKey(HKEY_LOCAL_MACHINE, KeyPath, arrSubKeys) = 0 Then
				WriteToFile("************* Failed to remove installation " & objPNPFile & " *************")
			Else
				WriteToFile("Installation " & sProductCode & " removed successfully")
			end if
		End If
	Next
	If Err.Number <> 0 Then
		WriteToFile("************* Error removing driver: " & Err.Description & " on line " & Err.Line & " *************")
		Err.Clear
	end if
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub RemoveDriver(sModelMask)
'forcibly removes Printer Driver and writes details to log file
	on error resume Next
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	set colInstalledPrinters =  objWMIService.ExecQuery("Select * from Win32_PrinterDriver where name like'%" & sModelMask & "%'")
	if colInstalledPrinters.count<>0 then
		For each objPrinterDriver in colInstalledPrinters
			WriteToFile("About to remove Driver: " & objPrinterDriver.name)
			set objDriver = objWMIService.Get("Win32_PrinterDriver.Name='" & objPrinterDriver.name & "'")
			sPrinterName=objPrinterDriver.name
			objDriver.Delete_
			WriteToFile("Driver " & sPrinterName & " removed successfully")
		Next
	end if
	Set colInstalledPrinters = Nothing
	Set objDriver = Nothing
	Set objWMIService = Nothing
	If Err.Number <> 0 Then
		WriteToFile("************* Error removing driver: " & Err.Description & " on line " & Err.Line & " *************")
		Err.Clear
	end if
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub RemoveINFfiles()
'remove INF files. mainly for XP but removes on all windows versions <6
	on error resume next
	set wshshell = CreateObject("Wscript.Shell")
	strFolder = "C:\windows\inf"
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	if objFSO.folderexists(strFolder) then
		WriteToFile("About to remove PNP INF Files")
		set objFolder = objFSO.GetFolder(strFolder)
		ifilecount=0
		For Each objFile In objFolder.Files
			if left(ucase(objFile.name),3)="OEM" and right(ucase(objFile.name),3)="INF"then
				Set objFilecont = objFSO.OpenTextFile(strFolder & "\" & objFile.name)
				Do Until objFilecont.AtEndOfStream or comp=1
    				strLine= objFilecont.ReadLine
					'if instr(1,strline,"Ultra Electronics",1) then filename = objFile.name
					if instr(1,strline,"Ultra Electronics",1) or _
						instr(1,strline,"Magicard",1) or _
						instr(1,strline,"UM_END.CAT",1) or _
						instr(1,strline,"UM_AOT.CAT",1) or _
						instr(1,strline,"UM_RT.CAT",1) or _
						instr(1,strline,"MAGU.CAT",1)then
							ReDim Preserve aPNPfiles(ifilecount)
							aPNPfiles(ifilecount) = objFile.name
							ifilecount = ifilecount+1
					end if
				Loop
				objFilecont.Close
			end if
		Next
		if ifilecount>0 then
			for each objPNPFile in aPNPfiles
				WriteToFile("Removing " & objPNPFile)
				objFSO.Deletefile(strFolder & "\" & objPNPFile)
				objFSO.Deletefile(strFolder & "\" & replace(objPNPFile,".inf",".PNF")),TRUE
				if objFSO.FileExists(strFolder & "\" & objPNPFile) then
					WriteToFile("************* Failed to remove " & objPNPFile & " *************")
				else
					WriteToFile(objPNPFile & " Removed")
				end if
			next
			WriteToFile("PNP INF Files removed successfully")
		else
			WriteToFile("No PNP INF Files to be removed")
		end if
	else
		wscript.echo sAppName & ": " & "PNP INF folder does not exist"
	end if
	Set objFolder = Nothing
	set objFilecont = Nothing
	Set objFSO = Nothing
	If Err.Number <> 0 Then
		WriteToFile("************* Error removing PNP INF Files: " & Err.Description & " on line " & Err.Line & " *************")
		Err.Clear
	end if
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub RemovePNPDrivers()
' uses pnputils to remove driver files removes all PNP files for windows version >=6
	on error resume next
	set wshshell = CreateObject("Wscript.Shell")
	strFolder = "C:\windows\inf"
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	if objFSO.folderexists(strFolder) then
		WriteToFile("About to remove PNP Drivers with pnputil")
		set objFolder = objFSO.GetFolder(strFolder)
		ifilecount=0
		For Each objFile In objFolder.Files
			if left(ucase(objFile.name),3)="OEM" and right(ucase(objFile.name),3)="INF"then
				Set objFilecont = objFSO.OpenTextFile(strFolder & "\" & objFile.name)
				comp=0
				Do Until objFilecont.AtEndOfStream or comp=1
    				strLine= objFilecont.ReadLine
					'if instr(1,strline,"Ultra Electronics",1) then filename = objFile.name
					if instr(1,strline,"Ultra Electronics",1) or _
						instr(1,strline,"Magicard",1) or _
						instr(1,strline,"UM_END.CAT",1) or _
						instr(1,strline,"UM_AOT.CAT",1) or _
						instr(1,strline,"UM_RT.CAT",1) or _
						instr(1,strline,"MAGU.CAT",1)then
							ReDim Preserve aPNPfiles(ifilecount)
							aPNPfiles(ifilecount) = objFile.name
							ifilecount = ifilecount+1
							comp=1
					end if
				Loop
				objFilecont.Close
			end if
		Next
		if ifilecount>0 then
			for each objPNPFile in aPNPfiles
				WriteToFile("Removing " & objPNPFile)
				wshshell.run "cmd /c pnputil -f -d " & objPNPFile,1,TRUE
				'wshshell.run "pnputil -f -d " & objPNPFile,7,TRUE
				'objFSO.Deletefile(strFolder & "\" & objPNPFile),TRUE
				WScript.Sleep 100
				if objFSO.FileExists(strFolder & "\" & objPNPFile) then
					WriteToFile("************* Failed to remove " & objPNPFile & " *************")
				else
					WriteToFile(objPNPFile & " Removed")
				end if
			next
			WriteToFile("PNP Drivers removed successfully with pnputil")
		else
			WriteToFile("No PNP Drivers to be removed with pnputil")
		end if
	else
		wscript.echo sAppName & ": " & "PNP folder does not exist"
	end if
	Set objFolder = Nothing
	set objFilecont = Nothing
	Set objFSO = Nothing
	If Err.Number <> 0 Then
		WriteToFile("************* Error removing PNP drivers: " & Err.Description & " on line " & Err.Line & " *************")
		Err.Clear
	end if
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function RemoveFiles(sArchitecture)
'removes all magicard printer related files from System32, SysWOW64 and spooler folders. writes details to
'log file using WriteToFile sub routine
	on error resume next
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	objWMIService.Security_.Privileges.AddAsString "SeLoadDriverPrivilege", True
	Set objFSO = CreateObject("Scripting.FileSystemObject")

'	remove driver files
	strFolder = "C:\Windows\System32\spool\drivers\" & sArchitecture
	Set objFolder = objFSO.GetFolder(strFolder)
	For Each objFile in objFolder.Files
		fileAndPath=objFile
		FileName =objFSO.GetFileName(objFile)
		if left(FileName,3) = "UM_" or left(FileName,3) = "MAG" then
			DeleteAFile fileAndPath
		end if
	Next

	strFolder = "C:\Windows\System32\spool\drivers\" & sArchitecture & "\3"
	Set objFolder = objFSO.GetFolder(strFolder)
	For Each objFile in objFolder.Files
		fileAndPath=objFile
		FileName =objFSO.GetFileName(objFile)
		if left(FileName,3) = "UM_" or left(FileName,3) = "MAG" then
			DeleteAFile fileAndPath
		end if
	Next

	'Remove language monitors
	sFileName = "C:\Windows\System32\UM_ENDLM.DLL"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\System32\UM_RTLM.DLL"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\System32\UM_AOTLM.DLL"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\System32\MAGMON.DLL"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\System32\OPTMON.DLL"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\System32\HLXMON.DLL"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\System32\HLXMON.DL1"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\System32\MAGMON.DL1"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\System32\PRO2MON.DLL"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\System32\status.exe"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	'co installer files
	sFileName = "C:\Windows\System32\ulcoinst.dll"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\System32\ulcoamd64.dll"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\SysWOW64\ulcoinst.dll"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	sFileName = "C:\Windows\SysWOW64\ulcoamd64.dll"
	if objFSO.FileExists(sFileName) then
		DeleteAFile sFileName
	end if

	'remove temp spooler files
	strFolder = "C:\Windows\System32\spool\Drivers\" & sArchitecture & "\3\temp"
	if objfso.folderexists(strFolder) then
		Set objFolder = objFSO.GetFolder(strFolder)
		for each objfile in objFolder.files
			filename=objFile
			if instr(1,filename,"MAG",1) then
				WriteToFile("Removing " & filename)
				objFSO.DeleteFile(filename),TRUE
				if objFSO.FileExists(filename) then
					WriteToFile("************* Failed to remove " & filename & " *************")
					brestart=true
				else
					WriteToFile(filename & " Removed")
				end if
			end if
		next
	end if

	'remove print processers
	strFolder = "C:\Windows\System32\spool\prtprocs\" & sArchitecture
	Set objFolder = objFSO.GetFolder(strFolder)
	For Each objFile in objFolder.Files
		filename=objFile
		if instr(1,filename,"UM_ENDS",1) then
			WriteToFile("Removing " & filename)
			objFSO.DeleteFile(filename),TRUE
			if objFSO.FileExists(filename) then
				WriteToFile("************* Failed to remove " & filename & " *************")
			else
				WriteToFile(filename & " Removed")
			end if
		elseif instr(1,filename,"UM_RTS",1) then
			WriteToFile("Removing " & filename)
			objFSO.DeleteFile(filename),TRUE
			if objFSO.FileExists(filename) then
				WriteToFile("************* Failed to remove " & filename & " *************")
			else
				WriteToFile(filename & " Removed")
			end if
		elseif instr(1,filename,"UM_AOTS",1) then
			WriteToFile("Removing " & filename)
			objFSO.DeleteFile(filename),TRUE
			if objFSO.FileExists(filename) then
				WriteToFile("************* Failed to remove " & filename & " *************")
			else
				WriteToFile(filename & " Removed")
			end if
		elseif instr(1,filename,"MAGPRINT",1) then
			WriteToFile("Removing " & filename)
			objFSO.DeleteFile(filename),TRUE
			if objFSO.FileExists(filename) then
				WriteToFile("************* Failed to remove " & filename & " *************")
			else
				WriteToFile(filename & " Removed")
			end if
		end if
	Next

	'remove print drivers from PCC
	strFolder = "C:\Windows\System32\spool\drivers\" & sArchitecture & "\PCC"
	Set objFolder = objFSO.GetFolder(strFolder)
	For Each objFile in objFolder.Files
		filename=objFile
		if instr(1,filename,"MAGU.INF",1) then
			WriteToFile("Removing " & filename)
			objFSO.DeleteFile(filename),TRUE
			if objFSO.FileExists(filename) then
				WriteToFile("************* Failed to remove " & filename & " *************")
			else
				WriteToFile(filename & " Removed")
			end if
		end if
	Next

	set colListOfServices = Nothing
	set objSpooler = Nothing

	If Err.Number <> 0 Then
		if startspooler=false then
			WriteToFile("Starting Print spooler")
			startspooler
			if startspooler=false then
				WriteToFile("************* Failed to start print spooler *************")
			else
				WriteToFile("Print spooler started")
			end if
		end if
		WriteToFile("************* Error Removing Redundant files: " & Err.Description & " on line " & Err.Line & " *************")
		Err.Clear
	end if
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function RemoveFolders(colFolderMask, sArchitecture)
'removes all magicard printer related folders from driver folder. writes details to
'log file using WriteToFile sub routine
	'on error resume next
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	objWMIService.Security_.Privileges.AddAsString "SeLoadDriverPrivilege", True
	set objSpooler = objWMIService.Get("Win32_Service.Name='Spooler'")

	strFolderToSearch = "C:\Windows\System32\spool\drivers\" & sArchitecture
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	Set objRootFolder = objFSO.GetFolder(strFolderToSearch)
	Set colSubfolders = objRootFolder.SubFolders

	for each objFolderMask in colFolderMask
		For Each objSubFolder in colSubfolders
			FolderName=objSubFolder.name
			DelFolder=objSubFolder
			if instr(1,FolderName,Replace(objFolderMask," ","_"),1)then
				'if objSubFolder.count<>0 then
					WriteToFile("Removing Redundant Files for " & objFolderMask )
					for each sFileName in objSubFolder.files
						DelFile = sFileName
						objFSO.DeleteFile(DelFile),TRUE
					next
					WriteToFile("Redundant Files for " & objFolderMask & " removed successfully")
				'end if
				WriteToFile("Removing Redundant Folders for " & objFolderMask )
				objFSO.Deletefolder(DelFolder)
				WriteToFile("Redundant Folders for " & objFolderMask & " removed successfully")
			end if
		Next
	next

	set objFSO = nothing
	Set objRootFolder = nothing
	Set colSubfolders = nothing
	If Err.Number <> 0 Then
		if startspooler=false then
			startspooler
			if startspooler=false then
				WriteToFile("************* Failed to start print spooler *************")
			else
				WriteToFile("Print spooler started")
			end if
		end if
		WriteToFile("************* Error Removing Redundant files/folders: " & Err.Description & " on line " & Err.Line & " *************")
		Err.Clear
	end if
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function RemoveRegKeys(arrModelMask)
'removes all magicard driver related registry keys for related printer. using the DeleteRegKey sub routine
	set wshshell = CreateObject("Wscript.Shell")

	Set objReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")
	objReg.Security_.Privileges.AddAsString "SeLoadDriverPrivilege", True

	strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Monitors\Enduro Language Monitor"
	intRegRoot = HKEY_LOCAL_MACHINE
	if RegKeyExists(intRegRoot, strKeyPath) Then DeleteRegKey intRegRoot, strKeyPath

	for each sModelMask in arrModelMask
		strKeyPath = "SOFTWARE\Ultra Electronics Card Systems Ltd." & sModelMask
		intRegRoot = HKEY_LOCAL_MACHINE
		DeleteRegKey intRegRoot, strKeyPath
	next

	strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Monitors\AOTA Language Monitor"
	intRegRoot = HKEY_LOCAL_MACHINE
	DeleteRegKey intRegRoot, strKeyPath

	strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Monitors\Rio/Tango 2e Language Monitor"
	intRegRoot = HKEY_LOCAL_MACHINE
	DeleteRegKey intRegRoot, strKeyPath

	strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Monitors\Ultra Language Monitor"
	intRegRoot = HKEY_LOCAL_MACHINE
	DeleteRegKey intRegRoot, strKeyPath

	strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Monitors\Ultra Optima Language Monitor"
	intRegRoot = HKEY_LOCAL_MACHINE
	DeleteRegKey intRegRoot, strKeyPath

	if 	funcArchitecture= "w32x86" then
		strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Environments\Windows NT x86\Print Processors\UM_ENDS"
	elseif funcArchitecture="x64" then
		strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Environments\Windows x64\Print Processors\UM_ENDS"
	end if
	intRegRoot = HKEY_LOCAL_MACHINE
	DeleteRegKey intRegRoot, strKeyPath

	if 	funcArchitecture= "w32x86" then
		strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Environments\Windows NT x86\Print Processors\UM_RTS"
	elseif funcArchitecture="x64" then
		strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Environments\Windows x64\Print Processors\UM_RTS"
	end if
	intRegRoot = HKEY_LOCAL_MACHINE
	DeleteRegKey intRegRoot, strKeyPath

	if 	funcArchitecture= "w32x86" then
		strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Environments\Windows NT x86\Print Processors\UM_AOTS"
	elseif funcArchitecture="x64" then
		strKeyPath = "SYSTEM\CurrentControlSet\Control\Print\Environments\Windows x64\Print Processors\UM_AOTS"
	end if
	intRegRoot = HKEY_LOCAL_MACHINE
	DeleteRegKey intRegRoot, strKeyPath

	strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall"
	intRegRoot = HKEY_LOCAL_MACHINE
	for each sModel in arrModelMask
		DeleteRegKey intRegRoot, strKeyPath & "\" & sModel
	Next

	strRegKey = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall"
	intRegHive = HKEY_LOCAL_MACHINE
	strValueName = "Publisher"
	If objReg.EnumKey(intRegHive, strRegKey, arrSubKeys) = 0 Then
		For Each sKey In arrSubKeys
			objReg.GetStringValue HKEY_LOCAL_MACHINE,strKeyPath & "\" & skey,strValueName,strValue
			If IsNull(strValue) = false and strvalue = "Ultra Electronics Ltd" Then
				if sGUID(0)="" then
					sGUID=replace(replace(skey,"{",""),"}","")
				else
					Redim preserve sGUID(ubound(sGUID)+1)
					sGUID(ubound(sGUID))=replace(replace(skey,"{",""),"}","")
				end if
				WriteToFile("Removing: HKEY_LOCAL_MACHINE" & "\" & strKeyPath & "\" & sKey)
				objReg.DeleteKey HKEY_LOCAL_MACHINE, strKeyPath & "\" & sKey
				If objReg.EnumKey(HKEY_LOCAL_MACHINE, strKeyPath & "\" & sKey, arrSubKeys) = 0 Then
					WriteToFile("************* FAILED TO REMOVE: HKEY_LOCAL_MACHINE" & "\" & sKey & " *************")
				else
					WriteToFile("HKEY_LOCAL_MACHINE" & "\" & sKey  & " Removed")
				end if
			end if
		Next
	end if

	if sGUID<>"" then
		strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Installer\UserData\S-1-5-18\Products"
		strValueName = "ModifyPath"
		objReg.EnumKey HKEY_LOCAL_MACHINE, strKeyPath, aSub
			For Each sKey In aSub
				objReg.GetStringValue HKEY_LOCAL_MACHINE,strKeyPath & "\" & skey & "\InstallProperties",strValueName,strValue
				for each sGUIDKeyVal in sGUID
					If instr(1,strValue,sGUIDKeyVal,1) Then
						objReg.EnumKey HKEY_LOCAL_MACHINE,strKeyPath & "\" & skey, aSub2
						for each skey2 in asub2
							WriteToFile("Removing: HKEY_LOCAL_MACHINE" & "\" & strKeyPath & "\" & sKey & "\" & skey2)
							objReg.DeleteKey HKEY_LOCAL_MACHINE, strKeyPath & "\" & sKey & "\" & skey2
							If objReg.EnumKey(HKEY_LOCAL_MACHINE, strKeyPath & "\" & sKey & "\" & skey2, arrSubKeys) = 0 Then
								WriteToFile("************* FAILED TO REMOVE: HKEY_LOCAL_MACHINE" & "\" & sKey & "\" & skey2 & " *************")
							else
								WriteToFile("HKEY_LOCAL_MACHINE" & "\" & sKey & "\" & skey2 & " Removed")
							end if
						next
						WriteToFile("Removing: HKEY_LOCAL_MACHINE" & "\" & strKeyPath & "\" & sKey)
						objReg.DeleteKey HKEY_LOCAL_MACHINE, strKeyPath & "\" & sKey
						If objReg.EnumKey(HKEY_LOCAL_MACHINE, strKeyPath & "\" & sKey, arrSubKeys) = 0 Then
							WriteToFile("************* FAILED TO REMOVE: HKEY_LOCAL_MACHINE" & "\" & sKey & " *************")
						else
							WriteToFile("HKEY_LOCAL_MACHINE" & "\" & sKey & " Removed")
						end if
					end if
				next
			Next
	end if


	strRegKey = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall"
	intRegHive = HKEY_LOCAL_MACHINE
	strValueName = "Publisher"
	If objReg.EnumKey(intRegHive, strRegKey, arrSubKeys) = 0 Then
		For Each sKey In arrSubKeys
			objReg.GetStringValue HKEY_LOCAL_MACHINE,strKeyPath & "\" & skey,strValueName,strValue
			If IsNull(strValue) = false and strvalue = "Ultra Electronics Ltd" Then
				if sGUID(0)="" then
					sGUID=replace(replace(skey,"{",""),"}","")
				else
					Redim preserve sGUID(ubound(sGUID)+1)
					sGUID(ubound(sGUID))=replace(replace(skey,"{",""),"}","")
				end if
				WriteToFile("Removing: HKEY_LOCAL_MACHINE" & "\" & strKeyPath & "\" & sKey)
				objReg.DeleteKey HKEY_LOCAL_MACHINE, strKeyPath & "\" & sKey
				If objReg.EnumKey(HKEY_LOCAL_MACHINE, strKeyPath & "\" & sKey, arrSubKeys) = 0 Then
					WriteToFile("************* FAILED TO REMOVE: HKEY_LOCAL_MACHINE" & "\" & sKey & " *************")
				else
					WriteToFile("HKEY_LOCAL_MACHINE" & "\" & sKey  & " Removed")
				end if
			end if
		Next
	end if

	strRegKey = "Installer\Products"
	intRegHive = HKEY_CLASSES_ROOT
	strValueName = "ProductIcon"
	strSearch = "0F1729DA-0C3D-4AFE-B7F8-D86DB951A445"

	Select case intRegHive
		case HKEY_CLASSES_ROOT
			strRegHive = "HKEY_CLASSES_ROOT"
		case HKEY_CURRENT_USER
			strRegHive = "HKEY_CURRENT_USER"
		case HKEY_LOCAL_MACHINE
			strRegHive = "HKEY_LOCAL_MACHINE"
		case HKEY_USERS
			strRegHive = "HKEY_USERS"
		case HKEY_CURRENT_CONFIG
			strRegHive = "HKEY_CURRENT_CONFIG"
	end Select

	Set objReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")
	objReg.Security_.Privileges.AddAsString "SeLoadDriverPrivilege", True
	If objReg.EnumKey(intRegHive, strRegKey, arrSubKeys) = 0 Then
		For Each sKey In arrSubKeys
			objReg.GetStringValue intRegHive,strRegKey & "\" & skey,strValueName,strValue
			If IsNull(strValue) = false and InStr(1,strValue,strSearch,vbTextCompare)<>0 Then
					WriteToFile("Removing: " & strRegHive & "\" & strKeyPath & "\" & sKey)
					WshShell.run("REG.EXE DELETE " & strRegHive &"\" & strRegKey & "\" & sKey & " /f")
					If objReg.EnumKey(intRegHive, strKeyPath & "\" & sKey, arrSubKeys) = 0 Then
						WriteToFile("************* FAILED TO REMOVE: " & strRegHive & "\" & sKey & " *************")
					else
						WriteToFile(strRegHive & "\" & sKey  & " Removed")
					end if
			end if

		Next
	end if

	Set objReg = Nothing
	set wshShell = nothing
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub DeleteRegKey(ByVal intRegHive, ByVal strRegKey)
	' removes registry key and sub keys given in strRegKey and records the status of each event (success or failure) in WriteToFile function
	Dim arrSubkeys
	Dim strRegHive
	'set the hive string for log entries
	Select case intRegHive
		case HKEY_CLASSES_ROOT
			strRegHive = "HKEY_CLASSES_ROOT"
		case HKEY_CURRENT_USER
			strRegHive = "HKEY_CURRENT_USER"
		case HKEY_LOCAL_MACHINE
			strRegHive = "HKEY_LOCAL_MACHINE"
		case HKEY_USERS
			strRegHive = "HKEY_USERS"
		case HKEY_CURRENT_CONFIG
			strRegHive = "HKEY_CURRENT_CONFIG"
	end Select
	'set objreg as registry object
	Set objReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")
	'elevate the permissions
	objReg.Security_.Privileges.AddAsString "SeLoadDriverPrivilege", True
	'enumerate key and feed values into arrSubkeys
	If objReg.EnumKey(intRegHive, strRegKey, arrSubKeys) = 0 Then
		If IsArray(arrSubkeys) Then
			'loop throughsub keys
			For Each strSubkey In arrSubkeys
				'delete sub key in strSubkey
				objReg.DeleteKey intRegHive, strRegKey & "\" & strSubkey
				'check to see if key has been deleted
				If objReg.EnumKey(intRegHive, strRegKey & "\" & strSubkey, arrSubKeys) = 0 Then
					'add line in log file, failed to delete key
					WriteToFile("************* FAILED TO REMOVE SUBKEY: " & strRegHive & "\" & strRegKey & "\" & strSubkey & " *************")
				else
					'add line to log file, removal successful
					WriteToFile(strRegHive & "\" & strRegKey & "\" & strSubkey & " Removed")
				end if
			Next
		End If
		'delete reg key in strRegKey
		objReg.DeleteKey intRegHive, strRegKey
		'check to see if key in strRegKey has been deleted
		If objReg.EnumKey(intRegHive, strRegKey, arrSubKeys) = 0 Then
			'add line in log file, failed to delete key
			WriteToFile("************* FAILED TO REMOVE: " & strRegHive & "\" & strRegKey & " *************")
		else
			'add line to log file, removal successful
			WriteToFile(strRegHive & "\" & strRegKey & " Removed")
		end if
	end if
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function RegKeyExists(intRegHive, strRegKey)
	'checks to see if key exists. returns a true if reg key is present
    Dim oReg: Set oReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")
    If oReg.EnumKey(intRegHive, strRegKey, arrSubKeys) = 0 Then
        RegKeyExists = True
    Else
        RegKeyExists = False
   End If
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub DeleteAFile(fileNameAndPath)
'deletes file given in fileNameAndPath and writes details in log using WriteToFile sub routine
   Dim fso
   Set fso = CreateObject("Scripting.FileSystemObject")
   fso.DeleteFile(fileNameAndPath)
	if FSO.FileExists(fileNameAndPath) then
		WriteToFile("************* Failed to remove " & fileNameAndPath & " *************")
	else
		WriteToFile(fileNameAndPath & " Removed")
	end if
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function WriteToFile(LineToWrite)
'writes string given in LineToWrite with time and date stamp to log file in the same location as this script
	strOutputFile = "./" & left(WScript.ScriptName,instrrev(WScript.ScriptName,chr(46))-1) & ".Log"
	Set objFSO = CreateObject("Scripting.fileSystemObject")
	if objFSO.fileexists(strOutputFile) then
		Set objOutputFile = objFSO.openTextFile(strOutputFile, 8)
	else
		Set objOutputFile = objFSO.CreateTextFile(strOutputFile, TRUE)
	end if
	objOutputFile.WriteLine ( Now & ": " & LineToWrite )
	objOutputFile.Close
	Set objFSO = Nothing
end function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
sub restart()
'restarts system
	Set OpSysSet = GetObject("winmgmts:{authenticationlevel=Pkt," _
		& "(Shutdown)}").ExecQuery("select * from Win32_OperatingSystem where "_
		& "Primary=true")
	for each OpSys in OpSysSet
		retVal = OpSys.Win32Shutdown(2)
	next
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''' End of Functions and Sub routines ''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
